

// line 9 "CustomGibbsSampler.jweb"
/* $Header: /home/warneg/CVS/Hydra/org/omegahat/Simulation/MCMC/CustomGibbsSampler.java,v 1.1.1.1 2001/04/04 17:16:11 warneg Exp $  */
/* (c) 1999 by the Omegahat Project */


// line 134 "CustomGibbsSampler.jweb"
    package org.omegahat.Simulation.MCMC;


// line 140 "CustomGibbsSampler.jweb"
    import org.omegahat.Simulation.MCMC.Proposals.*;
    import org.omegahat.Simulation.MCMC.Targets.*;
    import org.omegahat.Simulation.MCMC.Listeners.*;

import org.omegahat.Probability.Distributions.*;
import org.omegahat.Simulation.RandomGenerators.*;


// line 20 "CustomGibbsSampler.jweb"
/** 
 *  A Gibbs Sampler that uses an internal <code>FullConditionalProposal</code> to generate the next Markov state.
 */
public class CustomGibbsSampler extends CustomMarkovChain
{

    
// line 35 "CustomGibbsSampler.jweb"
    /* none */

// line 27 "CustomGibbsSampler.jweb"
    
// line 55 "CustomGibbsSampler.jweb"
public CustomGibbsSampler( ContainerState state, FullConditionalProposal generator )
{
    super( state, generator );
}


public CustomGibbsSampler( Object state, FullConditionalProposal generator )
{
    super( state, generator );
}

// line 28 "CustomGibbsSampler.jweb"
    
// line 48 "CustomGibbsSampler.jweb"
    /* none */

// line 29 "CustomGibbsSampler.jweb"
    
// line 73 "CustomGibbsSampler.jweb"
static public class NormalGenerator extends Normal implements FullConditionalProposal
{
    public Object generate( Object ignored )
    {
	return super.generate();
    }


    public Object[] generateSeveral( int howmany, Object[] ignored )
    {
	return super.generateSeveral( howmany );
    }

    public NormalGenerator( PRNG prng )
    {
	super( prng );
    }
}




public static class listenerPrinter implements MCMCListener
{
    public int step=0;
    public void notify( MCMCEvent e ){
	if( e instanceof GenericChainStepEvent )
	    {
		step++;
		System.out.println("** Notify : Chain Step Event #" + step + " ** ");
	    }
	else
	    System.out.println("** Notify: Unrecognized Event ** ");
	System.out.println("** Details:");
	System.out.println( e );
    }
}



public static void main( String[] argv )
{
    PRNG prng = new CollingsPRNG( (new CollingsPRNGAdministrator()).registerPRNGState() );

    Double[] state = new Double[1];
    state[0] = new Double( 0.0 );
    CustomGibbsSampler test = new CustomGibbsSampler( state, new NormalGenerator(prng) );
    listenerPrinter l = new listenerPrinter();

    test.registerListener(l);
    test.iterate(10);
}

    

// line 30 "CustomGibbsSampler.jweb"
}

