

// line 10 "CustomMetropolisSampler.jweb"
/* $Header: /home/warneg/CVS/Hydra/org/omegahat/Simulation/MCMC/CustomMetropolisSampler.java,v 1.1.1.1 2001/04/04 17:16:12 warneg Exp $  */
/* (c) 1999 by the Omegahat Project */


// line 124 "CustomMetropolisSampler.jweb"
    package org.omegahat.Simulation.MCMC;


// line 130 "CustomMetropolisSampler.jweb"
    import org.omegahat.Simulation.MCMC.Proposals.*;
    import org.omegahat.Simulation.MCMC.Targets.*;
    import org.omegahat.Simulation.MCMC.Listeners.*;

    import org.omegahat.Probability.Distributions.*;
    import org.omegahat.Simulation.RandomGenerators.*;


// line 21 "CustomMetropolisSampler.jweb"
/** 
 *  A Markov Sampler that uses an internal
 *  <code>SymmetricProposal</code> and
 *  <code>UnnormalizedDensity</code> to generate the next Markov
 *  state.  
 */
public class CustomMetropolisSampler extends CustomMetropolisHastingsSampler
{

    
// line 39 "CustomMetropolisSampler.jweb"
    /* Inherited from CustomMetropolisHastingsChain */

// line 31 "CustomMetropolisSampler.jweb"
    
// line 79 "CustomMetropolisSampler.jweb"
public CustomMetropolisSampler( ContainerState state, UnnormalizedDensity target, SymmetricProposal proposal, PRNG prng )
{
    super( state, target, proposal, prng);
}


public CustomMetropolisSampler( Object state, UnnormalizedDensity target, SymmetricProposal proposal, PRNG prng   )
{
    this( new ContainerState(state), target, proposal, prng );
}

// line 32 "CustomMetropolisSampler.jweb"
    

// line 53 "CustomMetropolisSampler.jweb"
protected double acceptanceProb( Object current, Object proposed )
{
  return  Math.exp( logAcceptanceProb( current, proposed ) );
}



protected double logAcceptanceProb( Object current, Object proposed )
{
  double numer = target.logUnnormalizedPDF ( proposed );
  double denom = target.logUnnormalizedPDF ( current );
  
  if( Double.isNaN(numer) )
	return Double.NEGATIVE_INFINITY;
  else if ( Double.isInfinite(denom) || Double.isNaN(denom) )
    return 0.0;
  else
    return  Math.min( 0.0, numer - denom );
}


// line 33 "CustomMetropolisSampler.jweb"
    

// line 98 "CustomMetropolisSampler.jweb"
public static void main( String[] argv )
{
    PRNG prng = new CollingsPRNG( (new CollingsPRNGAdministrator()).registerPRNGState() );

    double[] state = new double[2];
    state[0] = 0.0 ;
    state[1] = 0.0 ;

    CustomMetropolisSampler test = new CustomMetropolisSampler( state, 
                                                                new BivariateNormalDensity(),
                                                                new NormalMetropolisProposal(2,prng),
                                                                prng );
    listenerPrinter l = new listenerPrinter();

    test.registerListener(l);
    test.iterate(10);
}

    

// line 34 "CustomMetropolisSampler.jweb"
}

