

// line 4 "GeneralProposal.jweb"
/* $Header: /home/warneg/CVS/Hydra/org/omegahat/Simulation/MCMC/GeneralProposal.java,v 1.1.1.1 2001/04/04 17:16:12 warneg Exp $  */
/* (c) 1999 by the Omegahat Project */


// line 69 "GeneralProposal.jweb"
    package org.omegahat.Simulation.MCMC;


// line 75 "GeneralProposal.jweb"
    import org.omegahat.Simulation.MCMC.Proposals.*;
    import org.omegahat.Simulation.MCMC.Targets.*;
    import org.omegahat.Simulation.MCMC.Listeners.*;

    import org.omegahat.Probability.Distributions.*;


// line 15 "GeneralProposal.jweb"
/** 
 *  A General proposal distribution generates generates the next state using function of the current state. It must 
 *  Provide the methods defined in the interface <code>ConditionalDensity</code> so that the Metropolis-Hastings style generators
 *  can compute the acceptance probability.
 */
    public interface GeneralProposal extends MarkovProposal, ConditionalDensity
{

    
// line 36 "GeneralProposal.jweb"
/** 
 * Convenience method for computing the probability of proposing a move.  
 * <p>
 * Probably implemented as:<p>
 * <code>
 * double transitionProbability( Object from, Object to );<p>
 * {<p>
 *    return conditionalPDF( to, from );<p>
 * }<p>
 * </code><p>
 */
double transitionProbability( Object from, Object to );

/** 
 * Convenience method for computing the log probability of proposing a move.  
 * <p>
 * Probably implemented as:<p>
 * <code>
 * double logTransitionProbability( Object from, Object to );<p>
 * {<p>
 *    return logConditionalPDF( to, from );<p>
 * }<p>
 * </code><p>
 */
double logTransitionProbability( Object from, Object to );



// line 24 "GeneralProposal.jweb"
}

