

// line 9 "MultiTarget.jweb"
/* $Header: /home/warneg/CVS/Hydra/org/omegahat/Simulation/MCMC/MultiTarget.java,v 1.1.1.1 2001/04/04 17:16:13 warneg Exp $  */



// line 107 "MultiTarget.jweb"
package org.omegahat.Simulation.MCMC; 


// line 113 "MultiTarget.jweb"
    import org.omegahat.Simulation.MCMC.Proposals.*;
    import org.omegahat.Simulation.MCMC.Targets.*;
    import org.omegahat.Simulation.MCMC.Listeners.*;

import java.util.*;
import org.omegahat.Simulation.RandomGenerators.PRNG;
import org.omegahat.Probability.Distributions.*;


// line 20 "MultiTarget.jweb"
public class MultiTarget implements UnnormalizedDensity
{

  
// line 36 "MultiTarget.jweb"
UnnormalizedDensity[] targets;

// line 24 "MultiTarget.jweb"
  
// line 41 "MultiTarget.jweb"
// read-only
public    int numChains() { return targets.length; }

public void setTarget( int which, UnnormalizedDensity what )
{
  targets[which] = what;
}

public void setTargets( UnnormalizedDensity[] what )
{
  targets = what;
}




// line 26 "MultiTarget.jweb"
  
// line 60 "MultiTarget.jweb"
public double unnormalizedPDF   ( Object state )
{ 
return Math.exp( logUnnormalizedPDF(state) ); 
} 

public double logUnnormalizedPDF( Object state )
{
  MultiState states = (MultiState) state;

  double retval = 0.0;

  for(int i=0; i < targets.length; i++)
      retval += targets[i].logUnnormalizedPDF( states.get(i) );

  return retval;
}



// line 28 "MultiTarget.jweb"
  
// line 83 "MultiTarget.jweb"
public MultiTarget( int nchain )
{
    targets = new UnnormalizedDensity[nchain];
}

public MultiTarget( int nchain, UnnormalizedDensity singleTarget )
{
    targets = new UnnormalizedDensity[nchain];
    for(int i=0; i < targets.length; i++)
        targets[i] = singleTarget;
}

public MultiTarget( UnnormalizedDensity[] targetList )
{
    targets = targetList;
}




// line 30 "MultiTarget.jweb"
}

